#pragma OPENCL EXTENSION cl_khr_fp64: enable

__kernel void illumination(__global float *x_vec, __global float *y_vec, __global float *z_vec,
								  __global float *elev_in_vec_min, __global float *elev_in_vec_max,
								  __global float *az_file, __global float *sun_file, __global float *out)								
{

double PI = 3.1415926535897;
int j = get_global_id(0);

int size_roi = 10000;
double p;
double c;
double radius = 1737.4;
double lon0 = 0.0;
double lat0 = -90.0;
double rho = PI / 180.0;
double lat, lon;
double arg;

double z_interp;
double cx, cy, x1, y1, x2, y2, ix1, iy1, ix2, iy2, dx, dy, A, B, C, det, m,
			cline, alpha, area, xcart, ycart, zcart;
	
	float s;
	double radi_sun = (0.53 / 2.0);
	double dot_p, mod_a, mod_b;
	
	
double elev_file;
	double h, b;
	double h_s;

//--CHECK THE ID_MIN AND ID_MAX


				z_interp = elev_in_vec_min[j] + (elev_in_vec_max[j] - elev_in_vec_min[j]) * ((az_file[0] - sun_file[3]) / (sun_file[4] - sun_file[3]));
						
				//calculate elevation wrt position

				p = sqrt(x_vec[j] * x_vec[j] + y_vec[j] * y_vec[j]);
				c = atan(p / radius);
				lon = lon0 + atan2(x_vec[j] * sin(c), (p * cos(lat0 * rho)
						* cos(c) - y_vec[j] * sin(lat0 * rho) * sin(c))) / rho;
				lat = asin(cos(c) * sin(lat0 * rho) + y_vec[j] * sin(c) * cos(
						lat0 * rho) / p) / rho;
				if (lon < 0)
					lon += 360.0;

				xcart = (radius + z_vec[j]) * cos(lat * rho) * cos(lon * rho);
				ycart = (radius + z_vec[j]) * cos(lat * rho) * sin(lon * rho);
				zcart = (radius + z_vec[j]) * sin(lat * rho);
				
				//dot product
				dot_p = sun_file[0] * xcart + sun_file[1] * ycart + sun_file[2]
						* zcart;

				mod_a = sqrt(sun_file[0] * sun_file[0] + sun_file[1] * sun_file[1]
						+ sun_file[2] * sun_file[2]);

				mod_b = sqrt(xcart * xcart + ycart * ycart + zcart * zcart);

				elev_file = 90.0 - (acos(dot_p / (mod_a * mod_b)) * (180.0 / PI));

				cx = az_file[0];
				cy = elev_file;

				x1 = sun_file[3];
				x2 = sun_file[4];
				y1 = elev_in_vec_min[j];
				y2 = elev_in_vec_max[j];

				dx = x2 - x1;
				dy = y2 - y1;

				m = dy / dx;

				cline = y1 - m * x1;

				A = 1.0 + m * m;
				B = -2.0 * cx + 2.0 * m * cline - 2.0 * cy * m;
				C = cx * cx + cy * cy + cline * cline - 2.0 * cy * cline
						- radi_sun * radi_sun;

				det = (B * B) - (4.0 * A * C);
				
				if (det < 0) {
					//no intersects but might be above or not the horizon
					if (elev_file > z_interp) {
						out[j] = 1; //sun is visible
					} else {
						out[j] = 0;
					}

				} else {
				
					ix1 = (-B - sqrt(det)) / (2.0 * A);
					ix2 = (-B + sqrt(det)) / (2.0 * A);
					iy1 = ix1 * m + cline;
					iy2 = ix2 * m + cline;

					h = radi_sun - sqrt(pow((cx - 0.5 * (ix1 + ix2)), 2) + pow(
							(cy - 0.5 * (iy1 + iy2)), 2));
					
					h_s = radi_sun - h;
					
					s = sqrt(((ix2 - ix1) * (ix2 - ix1)) + ((iy2 - iy1) * (iy2
							- iy1)));
					
					alpha = 4.0 * atan(2.0 * h / s);
					b = radi_sun * alpha;
					area = radi_sun * b / 2.0 - s * (radi_sun - h) / 2.0;
					if ((elev_file > z_interp)) { //center sun above horizon-->+50%visible
						out[j] = (1 - area / (PI * radi_sun * radi_sun));								
					} else {
						out[j] = (1 - (PI * radi_sun * radi_sun - area)
								/ (PI * radi_sun * radi_sun));
					}
					if(out[j] < 0){
					out[j] = 0;
					}else if(out[j] > 1){
					out[j] = 1;
					}
								
				}
				//write out the visible portion
				//out[j] = flag_visible[j];		
		}	
		
		